<?php

namespace Ulmus\Query;

class Insert extends Fragment {

    public int $order = -100;

    public bool $quick = false;
    
    public bool $ignore = false;
    
    public array $fieldlist = [];
    
    public string $priority;
    
    public string $table;
    
    public ? string $alias = null;
    
    public function render() : string
    {
        return $this->renderSegments([
            'INSERT',
            ( $this->priority ?? false ),
            ( $this->ignore ? 'IGNORE' : false ),
            'INTO', $this->renderTable(), 
            "(" . implode(',', $this->fieldlist) . ")",
        ]);
    }

    protected function renderTable() : string
    {
        return "`$this->table`";
    }
}
