<?php

namespace Ulmus\Query;

class Limit extends Fragment {

    public int $order = 80;

    public int $limit = 0;
    
    public string $keyword = "LIMIT %d";

    public function set($limit) : self
    {
        $this->limit = $limit;
        
        return $this;
    }

    public function render() : string
    {
        if ( $this->limit < 0 ) {
            throw new \Exception("An error occured trying to render the LIMIT fragment ; given value has to be > 0. Received {$this->limit}");
        }
        
        return $this->renderSegments([
            sprintf($this->keyword, abs($this->limit))
        ]);
    }
}
